%define section free

Summary:        AspectJ aspect-oriented language extension to Java
Name:           aspectj
Version:        1.1.1
Release:        1jpp
Epoch:          0
License:        Eclipse Public License
URL:            http://eclipse.org/aspectj/index.html
Group:          Development/Compilers
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        aspectj-1.1.1-src.tar.gz
# cvs -d :pserver:anonymous@dev.eclipse.org:/home/technology login 
# cvs -z3 -d :pserver:anonymous@dev.eclipse.org:/home/technology export -D "September 19, 2003 09:30am" org.aspectj/modules
Source1:        aspectj-build-build.xml
Source2:        aspectj-jdtcore4aspectj-build.xml
Patch0:         aspectj-docs-build_xml.patch
Patch1:         aspectj-AsmElementFormatter-workaround.patch
BuildRequires:  jpackage-utils >= 0:1.5.32, junit >= 0:3.8.1
BuildRequires:  ant >= 0:1.5.4, ant-optional >= 0:1.5.4
BuildRequires:  java-1.3.1, java-1.4.2
BuildRequires:  bcel >= 0:5.1
BuildRequires:  jakarta-commons-beanutils >= 0:1.6.1
BuildRequires:  jakarta-commons-collections >= 0:2.1
BuildRequires:  jakarta-commons-digester >= 0:1.5
BuildRequires:  jakarta-commons-logging >= 0:1.0.3
BuildRequires:  regexp >= 0:1.3
BuildRequires:  saxon >= 0:6.5.3
BuildRequires:  xalan-j2 >= 0:2.5.2
BuildRequires:  xerces-j2 >= 0:2.6.0
BuildRequires:  xml-commons-apis >= 0:1.0
Requires:  bcel >= 0:5.1
Requires:  jakarta-commons-beanutils >= 0:1.6.1
Requires:  jakarta-commons-collections >= 0:2.1
Requires:  jakarta-commons-digester >= 0:1.5
Requires:  jakarta-commons-logging >= 0:1.0.3
Requires:  regexp >= 0:1.3
Requires:  saxon >= 0:6.5.3
Requires:  xalan-j2 >= 0:2.5.2
Requires:  xerces-j2 >= 0:2.6.0
Requires:  xml-commons-apis >= 0:1.0
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
AspectJ is a seamless aspect-oriented language 
extension to Java(tm). It can be used to cleanly 
modularize the crosscutting structure of concerns 
such as exception handling, multi-object protocols, 
synchronization, performance optimizations, and 
resource sharing. When implemented in a 
non-aspect-oriented fashion, the code for these concerns 
typically becomes spread out across entire programs. 
AspectJ controls such code-tangling and makes the 
underlying concerns more apparent, making programs 
easier to develop and maintain. The project goal 
is to support the AspectJ compiler and core tools. 

%package installer
Summary:        Installer for %{name}
Group:          Development/Compilers

%description installer
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Docs for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n org.%{name}
export JAVA_HOME=/usr/lib/jvm/java-1.3.1-sun
cp %{SOURCE1} modules/build/build-build.xml
cp %{SOURCE1} modules/org.eclipse.jdt.core/build.xml
# save local jdiff sources
( cd modules/lib/jdiff
  unzip jdiff.jar
  rm jdiff.jar
  rm -rf jdiff
  $JAVA_HOME/bin/javac -d . -sourcepath src `find src -name "*.java"`
  $JAVA_HOME/bin/jar cf jdiff.jar.new jdiff
)
# remove all binary libs
# bundled aspectjrt.jar and aspectjtools.jar are 0 byte, though required
find . -name "*.jar" -a ! -name "aspectj*.jar" -exec rm {} \;
# next has been rebuilt from sources
mv modules/lib/jdiff/jdiff.jar.new modules/lib/jdiff/jdiff.jar
# throw 4 jakarta-commons from JPP into one jar
( cd modules/lib/commons
  jar xf $(find-jar commons-beanutils)
  jar xf $(find-jar commons-collections)
  jar xf $(find-jar commons-digester)
  jar xf $(find-jar commons-logging)
  jar cf commons.jar org
)

ln -s $(find-jar junit) modules/lib/junit/junit.jar
ln -s $(find-jar ant) modules/lib/ant/lib/ant.jar
ln -s $(find-jar ant-optional) modules/lib/ant/lib/optional.jar
ln -s $(find-jar xalan-j2) modules/lib/ant/lib/xalan.jar
ln -s $(find-jar xerces-j2) modules/lib/ant/lib/xercesImpl.jar
ln -s $(find-jar xml-commons-apis) modules/lib/ant/lib/xml-apis.jar
ln -s $(find-jar bcel) modules/lib/bcel/bcel.jar
ln -s $(find-jar regexp) modules/lib/regexp/jakarta-regexp-1.2.jar
ln -s $(find-jar saxon) modules/lib/saxon/saxon.jar

mv modules/build/build-properties.xml modules/build/build-properties.xml.orig
sed -e 's|"DEVELOPMENT"|"1.1.1"|' modules/build/build-properties.xml.orig \
		> modules/build/build-properties.xml

%patch0
%patch1

%build
# according to explicit aspectj instructions
export JAVA_HOME=/usr/lib/jvm/java-1.3.1-sun
# CLASSPATH needed for rebuilds from sources
export CLASSPATH=$(build-classpath \
ant \
commons-beanutils \
commons-collections \
commons-digester \
commons-logging \
junit \
regexp \
saxon \
xalan-j2 \
xerces-j2 \
xml-commons-apis \
)
# rebuild jdtcore-for-aspectj.jar from sources
( cd modules/org.eclipse.jdt.core
  mkdir src
  cd src
  unzip ../jdtcore-for-aspectj-src.zip
  rm -rf javax
  rm -rf org/apache
  rm -rf org/w3c
  rm -rf org/xml
  cd ..
  cp %{SOURCE2} build.xml
  ant
)
cd modules/build
# rebuild the build-module from sources
ant -f build-build.xml
# do the product build
ant -f build.xml 
# do the release build
cd release
ant install	\
		-Dversion=%{version} -Dskip.cvs=true \
		-Daspectj.modules.dir=../.. \
		-Djava13.home=/usr/lib/jvm/java-1.3.1-sun \
		-Djava14.home=/usr/lib/jvm/java-1.4.2-sun \
	| tee build-log-release-aspectj-%{version}.txt
# do the test build
ant test	\
		-Dversion=%{version} -Dskip.cvs=true \
		-Daspectj.modules.dir=../.. \
		-Djava13.home=/usr/lib/jvm/java-1.3.1-sun \
		-Djava14.home=/usr/lib/jvm/java-1.4.2-sun \
		-Dskip.build=true \
	| tee test-log-release-aspectj-%{version}.txt


%install
rm -rf $RPM_BUILD_ROOT
# move manifest.mf to MANIFEST.MF
( cd modules/aj-build/dist/tools/lib
  mkdir tmp
  cd tmp
  jar xf ../aspectjtools.jar
  mv META-INF/manifest.mf META-INF/MANIFEST.MF
  jar cmf META-INF/MANIFEST.MF ../aspectjtools.jar org*
  rm -rf *
  jar xf ../aspectjrt.jar
  mv META-INF/manifest.mf META-INF/MANIFEST.MF
  jar cmf META-INF/MANIFEST.MF ../aspectjrt.jar org*
  cd ..
  rm -rf tmp
)
# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p modules/aj-build/dist/tools/lib/aspectjtools.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}tools-%{version}.jar
cp -p modules/aj-build/dist/tools/lib/aspectjrt.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}rt-%{version}.jar
cp -p modules/aj-build/dist/aspectj-1.1.1.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}installer-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr modules/aj-build/dist/docs/doc/api/* \
        $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

rm -rf modules/aj-build/dist/docs/doc/api

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr modules/aj-build/dist/docs/* \
        $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/*.html
%{_javadir}/aspectjrt*.jar
%{_javadir}/aspectjtools*.jar

%files installer
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/*.html
%{_javadir}/%{name}installer-%{version}.jar
%{_javadir}/%{name}installer.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}


%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}


%changelog

* Thu Feb 12 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.1.1-1jpp
- First JPackage build
